// Hotkey plugin template for Intangir's Plugin Engine
//
// NameSpoofer.cpp - Name Spoof for SC/BW 1.11
//
// This source is to show a couple more advanced/useful features that can easily be used
// in a plugin engine IPE plugin. This shows how to set up Hotkeys and shared memory over
// multiple processes.
//
// begun December 30, 1999
// modified august 1, 2001
// modified feb 9, 2002
// modified jan, 7, 2005

#include <windows.h>
#include <Commctrl.h>
#include "structures.h"
#include "resource.h"
#include "sharedmem.h"


#define RELVERSION		"v1.11"
#define RELDATE			"(1/7/2005)"
#define RELTEXT			"SC/BW 1.11 Name Spoofer\n"\
								"Created by Intangir\n"\
								"(aka Doom-Gaze)\n"\
								"Plugin Engine available at:\n"\
								"http://www.delinquentminds.com"
#define PLUGINDESC		"Name Spoofer"
#define PLUGINTARGET		"SC/BW 1.11"
#define REQVERSION		2.00	// required version of loader

#define DEFNAME			"Random Lamer"
#define DEFVKEY			VK_F9	// hotkey!
#define FILEMAPNAME		"namespooffilemap"

#define SC_NAMEOFFSET   0x19035310 // data offset of your name in battle.snp

// 1.11 = 0x19033310
//	1.10 = 0x19033310
// 1.09b	 0x190350A0
// 1.08 = 0x190314E8
// 1.07 = 0x1902B0A0

//globals
HINSTANCE         g_hInst; // global handle to the instance
SharedMemStruct*  g_pSM;   // global pointer to the shared memory

//prototypes
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason,LPVOID lpvReserved);
DllQueryStruct* WINAPI DllQuery();

BOOL Enable();
BOOL Disable();
BOOL Config(HWND hParent);
BOOL Refresh();
BOOL Detect();

LRESULT WINAPI KeyboardProc(int nCode,WPARAM wParam,LPARAM lParam);
BOOL WINAPI ConfigDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam);

// DllEntryPoint - point of entry when dll is loaded
BOOL WINAPI DllMain(HINSTANCE hInstDll, DWORD dwReason,LPVOID lpvReserved)
{
   static HANDLE hMapObject = NULL;  // handle to file mapping
   BOOL fInit;

   switch(dwReason)
   {
   case DLL_PROCESS_ATTACH:
      g_hInst = hInstDll;
      // create file mapping to paged memory so it can be shared across processes
      // the reason you have to do this is:
      // when you set a keyboard hook (not only keyboard hooks but most other windows hooks as well)
      // when whatever event the hook is set for is triggered the DLL that the hook is in
      // is loaded into the other processes virtual address space!
      // there are several advantages and disadvantages to this
      // advantages: you can access the memory of your target as if it were your own! its the same process!
      // disadvantages: your dll will be loaded into TWO different process!! the plugin engine loader's process
      // AND the target process! so when you set config info on the loader process it wont be used by the
      // dll loaded by the target! to get around this you can use filemapping to share memory
      // this is what is being done on in this function.
      // if you have more questions about this goto the www.delinquentminds.com plugin engine forum-DONT EMAIL ME!
		hMapObject = CreateFileMapping( 
			(HANDLE) 0xFFFFFFFF,    // use paging file
			NULL,                   // no security attributes
			PAGE_READWRITE,         // read/write access
			0,                      // size: high 32-bits
			sizeof(SharedMemStruct),// size: low 32 bits
			FILEMAPNAME);           // name of map object

      if (hMapObject == NULL)
         return FALSE;

      // find out of the map already existed or not
      fInit = (GetLastError() != ERROR_ALREADY_EXISTS);
		
      // Get a pointer to the file-mapped shared memory.
      g_pSM = (SharedMemStruct*) MapViewOfFile( 
         hMapObject,     // object to map view of
			FILE_MAP_WRITE, // read/write access
			0,              // high offset:  map from
			0,              // low offset:   beginning
			0);             // default: map entire file

      if (g_pSM == NULL) 
			return FALSE;

      // Initialize memory if map didnt already exist.
      if (fInit)
		{
			g_pSM->sDQS.dwSize = sizeof(DllQueryStruct);          // size of DQS
			g_pSM->sDQS.hDll = NULL;                              // this member is filled by the loader
			g_pSM->sDQS.dwReqVersion = (DWORD) REQVERSION * 100;  // required version (*100 so its not float)
			g_pSM->sDQS.dwState = HS_DISABLED;                    // initial state of hack
			strcpy(g_pSM->sDQS.szDesc, PLUGINDESC);               // fill the description string
			strcpy(g_pSM->sDQS.szTarget, PLUGINTARGET);           // fill target string (this is what user sees on cheat engine)
			g_pSM->sDQS.pfEnable  = Enable;					         // set all the pointers to your functions
			g_pSM->sDQS.pfDisable = Disable;
			g_pSM->sDQS.pfConfig  = Config;
			g_pSM->sDQS.pfRefresh = Refresh;
			g_pSM->sDQS.pfDetect  = Detect;
			g_pSM->hHook = NULL;                                  // this doesnt exsist yet(should be created when enabled)
			g_pSM->wHotKey = DEFVKEY;                             // set the default hotkey value
         strcpy(g_pSM->szSCBWName, DEFNAME);                   // set the default name
		}
		return TRUE;

	case DLL_PROCESS_DETACH:
		// called when dll is unloaded from a process
		UnmapViewOfFile(g_pSM);
		CloseHandle(hMapObject);									
		return TRUE;

	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		return TRUE;

	default:
		return FALSE;
	}
}

// DllQuery - called by loader to get DQS pointer
DllQueryStruct* WINAPI DllQuery()
{ 
	return &g_pSM->sDQS;
}

// Detect - called by the engine if auto-enable is on.
//          return TRUE (non-zero) if the target is detected, or your plugin can be enabled now
//          return FALSE if the target is not found or the plugin cant be enabled now
BOOL Detect()
{
   HWND hSCBWWnd;
   if(!(hSCBWWnd = FindWindow("SWarClass", "Brood War")))
      if(!(hSCBWWnd = FindWindow("SWarClass", "Starcraft")))
         if(!hSCBWWnd)
         {
            return FALSE;
         }
   return (BOOL) hSCBWWnd;
}

// Enable - enable the hack/plugin or set hooks
BOOL Enable()
{ 
   if(g_pSM->hHook)
	{
		MessageBox(NULL, "Already Enabled", "Error", MB_OK | MB_ICONERROR);
		return TRUE;
	}
   char szTemp[64];
	DWORD dwSCBWThreadId;
	HWND hSCBWWnd = (HWND) Detect();
	if(!hSCBWWnd)
	{
		wsprintf(szTemp, "Error Finding %s Process ID", g_pSM->sDQS.szTarget);
      MessageBox(NULL, szTemp, "Error", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	dwSCBWThreadId = GetWindowThreadProcessId(hSCBWWnd, NULL);
	if(!(g_pSM->hHook = SetWindowsHookEx(WH_KEYBOARD, (HOOKPROC) KeyboardProc, g_hInst, dwSCBWThreadId)))
	{
		MessageBox(NULL, "Error Setting Keyboard Hook.", "Error", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	g_pSM->sDQS.dwState = HS_ENABLED;
	return TRUE;
} 

// Disable - disable the hack/patch or unset hooks
BOOL Disable()
{ 
	char szTemp[64];
	if(!g_pSM->hHook)
	{
		MessageBox(NULL, "Already Disabled", "Error", MB_OK | MB_ICONERROR);
	}
	else if(!UnhookWindowsHookEx(g_pSM->hHook))
	{
		wsprintf(szTemp, "%s has terminated", g_pSM->sDQS.szTarget);
		MessageBox(NULL, szTemp, "Error", MB_OK | MB_ICONERROR);
	}
	else
		g_pSM->hHook = NULL;

	g_pSM->sDQS.dwState = HS_DISABLED;
    return TRUE;
} 
// Config - info/configuration of the hack/patch
//*This is where you would want to Display any information or configuration dialog boxes
// The parameter hParent is a handle to the Cheat Engine window and should be used as the
// parent for any message/dialog boxes
BOOL Config(HWND hParent)
{
   return DialogBox(g_hInst, MAKEINTRESOURCE(IDD_CONFIGDLG), hParent, (DLGPROC)ConfigDlgProc);
}

// Refresh - Refresh DQS called after Enable/Disable but before item is shown on list
BOOL Refresh()
{
   return TRUE;
} 

// this is the callback function for when the keyboard hook is triggered!
LRESULT WINAPI KeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	if(nCode==HC_ACTION && wParam==g_pSM->wHotKey && (lParam & 0x80000000))
	{
		strcpy((char*) SC_NAMEOFFSET, g_pSM->szSCBWName);
	}
	return CallNextHookEx(g_pSM->hHook, nCode, wParam, lParam);
}

// callback for processing Configure dialog box messages
BOOL WINAPI ConfigDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch(Msg)
	{
	case WM_INITDIALOG:
		SetDlgItemText(hDlg, IDC_NAME, g_pSM->szSCBWName);
		SendDlgItemMessage(hDlg, IDC_NAME, EM_LIMITTEXT, 15, NULL);
		SendDlgItemMessage(hDlg, IDC_HOTKEY, HKM_SETRULES, HKCOMB_A | HKCOMB_C | HKCOMB_CA | HKCOMB_S | HKCOMB_SA | HKCOMB_SC | HKCOMB_SCA, NULL);
		SendDlgItemMessage(hDlg, IDC_HOTKEY, HKM_SETHOTKEY, g_pSM->wHotKey, 0);
		SetDlgItemText(hDlg, IDC_RELVERSION, RELVERSION);
		SetDlgItemText(hDlg, IDC_RELDATE, RELDATE);
		SetDlgItemText(hDlg, IDC_RELTEXT, RELTEXT);
		return TRUE;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			g_pSM->wHotKey = (WORD) SendDlgItemMessage(hDlg, IDC_HOTKEY, HKM_GETHOTKEY, NULL, NULL);
			GetDlgItemText(hDlg, IDC_NAME, g_pSM->szSCBWName, 16);
		case IDCANCEL:
			EndDialog(hDlg, TRUE);
			return TRUE;
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
}
