// Simple plugin template for Intangir's Plugin Engine
//
//
//
// This source code shows the basics of what a simple plugin should do
// the rest is up to you!
//
//
// Writen Dec 3, 1999
// Edited Jan 13,2001
// Edited Jan 2, 2005

#include <windows.h> 
#include "structures.h"

#define PLUGINDESC		"Simple Plugin Template"
#define PLUGINTARGET		"None!"

#define REQVERSION		2.00	// required version of loader (Intangir's Plugin Engine is 2.00)
										// the plugin format has changed on version 2.0
//globals
HINSTANCE		g_hInst;
DllQueryStruct g_DllQueryStruct;

//prototypes
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason,LPVOID lpvReserved);
DllQueryStruct* WINAPI DllQuery();

BOOL Enable();
BOOL Disable();
BOOL Config(HWND hParent);
BOOL Refresh();
BOOL Detect();

// DllEntryPoint - point of entry when dll is loaded
BOOL WINAPI DllMain(HINSTANCE hInstDll, DWORD dwReason,LPVOID lpvReserved)
{
	switch(dwReason)
	{
	case DLL_PROCESS_ATTACH:
		// this code is run when the DLL is loaded
		// the DQS (dll query structure) must be filled here.
		g_hInst = hInstDll;
		g_DllQueryStruct.dwSize = sizeof(DllQueryStruct);			// give the size of the structure (might change in other versions)
		g_DllQueryStruct.hDll  = NULL;									// hDll is filled on the cheat engine side
		g_DllQueryStruct.dwReqVersion = (DWORD) REQVERSION*100;
		g_DllQueryStruct.dwState   = 0;									// initial state of the hack
		strcpy(g_DllQueryStruct.szDesc,PLUGINDESC);					// Set the description string
		strcpy(g_DllQueryStruct.szTarget,PLUGINTARGET);				// Set the target string (what you want user to see listed as target)
		g_DllQueryStruct.pfEnable  = Enable;							// Set pointers to all of the functions
		g_DllQueryStruct.pfDisable = Disable;							// (if you dont set a pointer for a function
		g_DllQueryStruct.pfConfig  = Config;							// then the engine obviously cant support it)
		g_DllQueryStruct.pfRefresh = Refresh;
		g_DllQueryStruct.pfDetect	= Detect;
		return TRUE;
	case DLL_PROCESS_DETACH:
		// add anything here that you want to be run when the DLL is unloaded
		// keep in mind that the loader does call disable before unloading!!
		// so you dont need to disable the hack here
		return TRUE;
	default:
		return FALSE;
	}
}

// DllQuery - called after DLL is loaded to get the DQS pointer
DllQueryStruct* WINAPI DllQuery()
{ 
	return &g_DllQueryStruct;
}

// Enable - enable the hack/plugin
// This is where you should open your target process and apply any hacks or change the data
BOOL Enable()
{ 
	// add your code here to enable your plugin

	// set the state to enabled ONLY if you successfully enable the plugin
	// if you fail to find a target process DONT set it to enabled!
	g_DllQueryStruct.dwState = HS_ENABLED;

	return TRUE;
} 

// Disable - disable the hack/plugin
// This is where you want to return the code to its original state to disable the hack
BOOL Disable()
{ 
	// add your code here to disable your plugin

	g_DllQueryStruct.dwState = HS_DISABLED;

	return TRUE;
} 

// Config - info/configuration of the hack/plugin
//*This is where you would want to Display any information on use or configuration dialog boxes
// The parameter hParent is a handle to the Cheat Engine window and should be used as the
// parent for any message/dialog boxes
BOOL Config(HWND hParent)
{ 
	// add your code here (or just add more stuff to the message box)
	MessageBox(hParent,"Info/Configuration","Config",MB_OK);

	return TRUE;
} 

// Refresh - Called before a plugins status is shown in the engine
BOOL Refresh()
{
	// most likely you wont need to put anything here

	// you could test to make sure your plugin is still enabled, change the text shown for the plugins title, etc
	return TRUE;
} 

// Detect - called by the engine if auto-enable is on.
//          return TRUE if the target is detected, or your plugin can be enabled now
//          return FALSE if the target is not found or the plugin cant be enabled now
BOOL Detect()
{
	// add your code here to detect your target process if you have one
	// if you detect your target and your plugin can be enabled return true

	// make sure your code for detection doesnt take to much time, this function could
	// potentially be called many times a second (depending on the detection interval set on the engine)

	return FALSE;
}