// structures.h

// DQS (dll query structure) for plugins made for version 2.0 of Intangir's Plugin Engine

typedef BOOL(*DLL_ENABLE)();
typedef BOOL(*DLL_DISABLE)();
typedef BOOL(*DLL_CONFIG)(HWND);
typedef BOOL(*DLL_REFRESH)();
typedef BOOL(*DLL_DETECT)();

enum { HS_DISABLED = 0, HS_ENABLED, HS_ERROR, HS_UNKNOWN}; // Hack States

// version 2.0 query struct
struct DllQueryStruct
{
   DWORD       dwSize;        // size of DQS
   HINSTANCE   hDll;          // used by loader to save hInstance of Dll
   DWORD       dwReqVersion;  // required version of plugin loader 
   DWORD       dwState;       // holds the state of the hack/plugin
   char        szDesc[32];    // description of the plugin
   char        szTarget[16];  // target string
   DLL_ENABLE  pfEnable;      // function pointers
   DLL_DISABLE pfDisable;
   DLL_CONFIG  pfConfig;
   DLL_REFRESH pfRefresh;
   DLL_DETECT  pfDetect;
};

typedef DllQueryStruct*(*DLL_QUERY)();
